%define name crossfire-client
%define version	1.0.0
%define sndversion 0.95.2
%define release 4mdk

Name: %{name}
Version: %{version}
Release: %{release}
Summary: Client for connecting to crossfire servers.
Group: Games/Adventure
License: GPL
URL: http://crossfire.real-time.com
# tar.gz files downloadable from ftp://ftp.scruz.net/users/mwedel/public/
Source: %{name}-%{version}.tar.bz2
Source1: client-%{sndversion}-au-sounds.tar.bz2
Source2: client-%{sndversion}-raw-sounds.tar.bz2
Source3: crossfire.desktop
Source4: %{name}-icons.tar.bz2
Patch:	%{name}-1.0.0-cvsfix1.patch.bz2
Patch1:	%{name}-1.0.0-cvsfix2.patch.bz2
Patch2:	%{name}-1.0.0-cvsfix3.patch.bz2
BuildRoot: %{_tmppath}/%{name}-buildroot
BuildPrereq: /usr/bin/perl
Requires: libpng3
BuildRequires: libpng3-devel

%description
Crossfire is a highly graphical role-playing adventure game with
characteristics reminiscent of rogue, nethack, omega, and gauntlet. 
It has multiplayer capability and presently runs under X11.

This package contains client for playing the new client/server based version
of Crossfire. It allows you to connect to crossfire servers around the world.
You do not need to install the crossfire server in order to use this package.


%package x11
Summary: X11 client for connecting to crossfire servers.
Group: Games/Adventure
BuildRequires: XFree86-devel libxpm4-devel libpng3-devel zlib1-devel

%description x11
Crossfire is a highly graphical role-playing adventure game with
characteristics reminiscent of rogue, nethack, omega, and gauntlet. 
It has multiplayer capability and presently runs under X11.

This package contains client for playing the new client/server based version
of Crossfire. It allows you to connect to crossfire servers around the world.
You do not need to install the crossfire server in order to use this package.

This is the original X11(Athena) version of the crossfire client.

%package gtk
Summary: GTK client for connecting to crossfire servers.
Group: Games/Adventure
BuildRequires: libgtk+1.2-devel

%description gtk
Crossfire is a highly graphical role-playing adventure game with
characteristics reminiscent of rogue, nethack, omega, and gauntlet. 
It has multiplayer capability and presently runs under X11.

This package contains client for playing the new client/server based version
of Crossfire. It allows you to connect to crossfire servers around the world.
You do not need to install the crossfire server in order to use this package.

This is GTK version of the crossfire client.


%package sounds
Summary: Sound effects for crossfire clients
Group: Games/Adventure

%description sounds
Crossfire is a highly graphical role-playing adventure game with
characteristics reminiscent of rogue, nethack, omega, and gauntlet. 
It has multiplayer capability and presently runs under X11.

This package contains sound effects for crossfire client.
It may not be absolutely necessary, but can add some fun for those who play
crossfire.


%prep
%setup -a 1 -a 2 -n %{name}-%{version}
%patch -p1
%patch1 -p1
%patch2 -p1

%build

# Prevent name clash with sounds.dist changed to sounds
mv sounds sound-files

%configure --with-sound-dir=/usr/share/sounds/crossfire --disable-alsa
# --with-sound-dir=xxxxxxxx doesn't change search path of clients!
#perl -pi -e 's#/usr/local/lib/sounds#/usr/share/sounds/crossfire#g' sound.c soundsdef.h
%make

%install
rm -rf %{buildroot}

mkdir -p %{buildroot}%{_prefix}/X11R6/{bin,man/man1}
%makeinstall mandir=%{buildroot}%{_prefix}/X11R6/man/man1 bindir=%{buildroot}%{_prefix}/X11R6/bin

mkdir -p %{buildroot}%{_datadir}/sounds/crossfire
install -m 0644 sound-files/*.{au,raw} %{buildroot}%{_datadir}/sounds/crossfire/

mkdir -p %{buildroot}%{_bindir}
mv %{buildroot}%{_prefix}/X11R6/bin/cfsndserv %{buildroot}%{_bindir}/

install -d %{buildroot}%{_datadir}/gnome/apps/Games
install %{SOURCE3} %{buildroot}%{_datadir}/gnome/apps/Games/
bzip2 -dc %{SOURCE4} | tar x -C %{buildroot}

mkdir -p %{buildroot}%{_menudir}
cat > %{buildroot}%{_menudir}/%{name}-gtk <<EOF
?package(%{name}-gtk): command="%{_prefix}/X11R6/bin/gcfclient -png -cache" \
section="Amusement/Other" icon="crossfire.png" needs="x11" \
title="GTK Crossfire Client" \
longtitle="Rogue-like graphical role-playing adventure game"
EOF
cat > %{buildroot}%{_menudir}/%{name}-x11 <<EOF
?package(%{name}-x11): command="%{_prefix}/X11R6/bin/cfclient -png -cache" \
section="Amusement/Other" icon="crossfire.png" needs="x11" \
title="X11 Crossfire Client" \
longtitle="Rogue-like graphical role-playing adventure game"
EOF

%post gtk
%{update_menus}

%postun gtk
%{clean_menus}

%post x11
%{update_menus}

%postun x11
%{clean_menus}

%clean
rm -rf %{buildroot}

%files x11
%defattr(-,root,root,-)
%doc README CHANGES COPYING
%{_prefix}/X11R6/bin/cfclient
%{_prefix}/X11R6/man/man1/cfclient.1*
%{_menudir}/%{name}-x11
%{_iconsdir}/crossfire.png
%{_liconsdir}/crossfire.png
%{_miconsdir}/crossfire.png

%files gtk
%defattr(-,root,root,-)
%doc README CHANGES COPYING
%{_prefix}/X11R6/bin/gcfclient
%{_prefix}/X11R6/man/man1/gcfclient.1*
%{_datadir}/gnome/apps/Games/crossfire.desktop
%{_iconsdir}/crossfire.png
%{_liconsdir}/crossfire.png
%{_miconsdir}/crossfire.png
%{_menudir}/%{name}-gtk

%files sounds
%defattr(-,root,root,-)
%{_bindir}/cfsndserv
%{_datadir}/sounds/crossfire
%doc sounds sound-files/README


%changelog
* Sat Dec 22 2001 Oden Eriksson <oden.eriksson@kvikkjokk.net> 1.0.0-4mdk
- rebuilt against libpng3.
- misc spec fixes.

* Wed May 30 2001 Abel Cheung <maddog@linux.org.hk> 1.0.0-3mdk
- Group and descriptions fix
- Oops I'm stupid, menu entry resides in wrong subpackage
- Intentionally let the icons in 2 clients overlap, till I figure
  out how to prevent this
- Add "-png -cache" argument to menu entries
- Seems CVS fixes don't work well, disable them for now
- Please blame Blue Lizard for this release :)

* Wed May 30 2001 Abel Cheung <maddog@linux.org.hk> 1.0.0-2mdk
- cfsndserv is expected to be under /usr/bin
- add menu entry for X11 crossfire client
- post/postun for x11 subpackage

* Mon May 14 2001 Abel Cheung <maddog@linux.org.hk> 1.0.0-1mdk
- Based on crossfire-client.spec in CVS
- 1.0.0 -- Hurray!
- More macros, but don't define _prefix anymore
- Bzip2'ed sources
- Add BuildRequires and BuildPrereq
- Add missing cfsndserv to sounds package
- Sounds really work now by default
- Modified Group, Summary and description
- Sounds package 0.95.4 doesn't exist, use 0.95.2. (In fact the 0.95.4
  packages ARE 0.95.2 packages)
- Move README and sample sound config from client package to sounds package
- Add menu entry for GTK version of client
- Rename SOURCE3 from client.gnome to crossfire-client.desktop
- Add smaller icons (resized from big one) and repackage as SOURCE4

* Mon May 14 2001 Bob Tanner <tanner@real-time.com>
- Rolled new client 1.0.0

* Sun May 13 2001 Mark Wedel <mwedel@scruz.net>
- player.c: Fix for client crashes if player enters really long commands (like
   say .....).
- gx11.c,command.c: Remove some debug statements which really should not be
  there for 1.0, and which are not really useful anyways.  items_types,
  item_types.h: Varioius minor updates.
- gx11.c: Fix bug that causes gtk client not to update weapon speed.
  metaserver.c: Have the listing get sorted by hostname to make it easier to
  find the host the user may want.

* Wed Apr 11 2001 Bob Tanner <tanner@real-time.com>
- Rolled new client 0.98.0 with Mark's changes listed next

* Tue Apr 10 2001 Mark Wedel <mwedel@scruz.net>
- Change matching for sword - hopefully this should fix problems with dancing
  sword spellbooks.
- Move animations of the look window to the client.  All the necessary was
  already being sent to the client - it was just needed for the client to use 
  this information.  Also remove some 
- Only resort items based on name if the name has changed.  This fixes a problem
  with items moving around in the inventory if you lock/apply/unapply/unlock 
  them. 

* Wed Mar 21 2001 Bob Tanner <tanner@real-time.com>
- Rolled new client 0.97.0 with Mark's changes listed next

* Tue Mar 20 2001 Mark Wedel <mwedel@scruz.net>
- Change so that containers on the ground still keep proper contents even if the
  map space itself changes (spells or other objects going onto the space). 
- commands.c: update the cpl.container tags when opening/closing containers.
- item.c: Have locate_object see if the container matches the tag.  Don't have
  remove_item remove the object contents of other attributes if it is the
  container, but still remove it from the list it is on.  
- item.h: remove function prototypes - these are in proto.h
- png.c: New png -> X11 (or gdk) creation routines that are much faster.  This
  should make a noticable difference in performance.  Note that the X11
  and gdk implementations are very different now - the gdk implementation
  lets the gdk library do most of the work.
- gx11.c: remove some dead code, add call to gdk_rgb_init() if using
  png images - needed by new png loader.
- x11.c: Add call to init_pngx_loader if running in png mode.  Also pass 
  colormap by pointer so png_to_xpixmap can modify it.
- xutil.c: pass colormap by pointer to init_pngx_loader (same reason as above)
- Makefile.in: Add DMALLOC_LIB definition instead of it going in with the
  the default libraries.  cfsndserv will now get properly linked with
  dmalloc.
- configure.in, configure: add --disable-sound option, and make relevant
  changes to use that option (which basically amounts to not checking
  for any of the sound systems).  Add check for dmalloc.h.  change
  substitution for -ldmalloc.
- cfsndserv.c: Modified so it now compiles with the modern ALSA sound system.
  No idea if it actually works.  MSW 2001/03/04
- metaserver.c: Modified so it uses the value of -port if that command
  line option is given by a user.  MSW 2001/03/01
- x11.c: Fixes for info window resizing.  This should fix some crashes
  and the code is a bit simpler now.  MSW 2001/02/28
- Makefile.in: Modify so that it installs the target (cfclient, gcfclient,
  cfsndserv) one at a time so it works with the install script.
- item.c: add insert_item_before_item function.  Modify the sorting function
  so it first sorts by type, then by locked/unlocked status, and then
 by alphabetical order (not including the number prefix).
- item_types, item_types.h: More updates of missing objects or ones that
  need more specific matching rules.
- x11.c: Remove a lot of duplicate code that was in place for metaserver
  support - instead, just add checks to the existing X event handling
  code to know not to do some things if we're in metaserver selection
  mode.  This fixes a bug in that resize events would not be handled
  if in metaserver selection mode.

* Tue Feb 13 2001 Bob Tanner <tanner@real-time.com>
- Rolled new client 0.96.0 with Mark's changes listed next

* Mon Feb 12 2001 Mark Wedel <mwedel@scruz.net>
- If compiled with dmalloc, add 'dmalloc command that verifies the heap.  Makes
  checking for memory corruption easier. 
- CHANGES, configure configure.in crossfire-client.spec: Update for 0.96.0
  release item_types item_types.h: Add some additional items.

* Sat Feb 10 2001 Bob Tanner <tanner@real-time.com>
- Created new Group for this package Amusements/Games/Crossfire

* Fri Feb 02 2001 Bob Tanner <tanner@real-time.com>
- Rolled new client with Mark's changes listed next 

* Tue Jan 30 2001 Mark Wedel <mwedel@scruze.net>
- Complete rewrite of the exit handling code.  Hopefully as an effect,
  this will fix the player appearing in the middle of the oceans.  I
  think the code should also work better in many other areas.  Main
  enhancements is a 3x3 area for pets to follow player to new map, as
  well as golems now following players to the new  maps. 
- include/sproto.h, random_maps/rproto.h - rebuilt.
- random_maps/random_map.c: Change generate_random_map to take a structure 
  with the random map paremeters.
- random_maps/reader.l, reader.c: Add set_random_map_variable function that
  reads the map parameters from a char buffer.  Also, remove some leftover
  comments that were from the common/loader.l file.
- random_maps/rogue_layout.c: Change some functions to be static so make proto
  doesn't collect them.
- random_maps/standalone.c: Add opening of parms file into main function since
  it ws removed from the random_map.c file.
- server/apply.c: Don't display the message of random maps to the players
  as they enter them, as this message is random map parameters, and not
  a real message.
- server/login.c: #if 0 out using of the player loading element in the
  structure.  this isn't used right now.
- server/main.c: Bulk of the changes.  main changes are to break apart
  the old enter_exit function into smaller functions that more
  logically do the needed function (random maps, unique maps, and
  transferring the player to the new map).  random map code now passes
  the parameters via structure instead of file in /tmp.  Code is much
  more understandable now and hopefully bugfree.
- server/pets.c: minor changes/bugfixes.  Search full SIZEOFFREE array, use
  real owner variable when print out messages.
- server/player.c: Remove usage of the loading variable in the player structure.

* Sun Jan 14 2001 Bob Tanner <tanner@real-time.com>
- Makefile.in: Create destination dirs, remove extra tab.  Patch also by Dave.
- Protocol: typo fixed.
- config.h, config.h.in: Add HVAE_DMALLOC_H #ifdefs.  Checks currently
  disable in configure.in, as with it, the sound won't like properly since
  it needs -ldmalloc, and I haven't bothered investing that much time
  into fixing the Makefile.
- gx11.c: Patches by Dave Peticolas - mostly code cleanup, but one new feature
  is support of wheel mice to move the scrollbars.
- png.c: No real code change, just adjustments in some ordering which I think
  makes the code appear a little simpler.
- x11.c: Minor code cleanups, some formatting changes, some to make better
  error messages.

* Wed Jan 08 2001 Bob Tanner <tanner@real-time.com>
- Applied MSW patch to change damge type to 16 bits

* Wed Jan 03 2001 Bob Tanner <tanner@real-time.com> [0.95.8-1]
- Upgraded client to 0.95.8
- Moved sounds into /usr/share/sounds/crossfire 
- Moved the prefix to /usr/X11R6
- Upgrade source file locations
- Made the gtk client GNOME aware and put the crossfire picture into
  Program->Games - Sounds are noarch

* Tue Mar 16 1999 Toshio Kuratomi <badger@prtr-13.ucsc.edu> [0.95.2-2]
- A few changes to conform to FHS 2.0
- Edit the sounds patch to place things in the /usr/share/sounds directory
  instead of /usr/share/sounds/sounds
- Rewrite certain parts of the script to rely more on the make install target
  rather than hacking it ourselves.
- We don't have to compile the program twice -- make all will create both the
  gtk and the Athena binaries.

* Sat Jan 30 1999 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.95.2-1]
- upgraded to version 0.95.2
- fixed minor bug in Makefile

* Sat Jan 23 1999 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.95.1-2]
- some bug fixes to the 0.95.1 release

* Tue Dec  8 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.95.1-1]
- upgraded to 0.95.1
- install sounds in /usr/share/sounds
- build both vanilla X client and GTK+ client

* Wed Dec  2 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.94.4-1]
- upgraded to 0.94.4

* Fri Sep  4 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org> [0.94.3-1]
- upgraded to version 0.94.3

* Tue Jun 02 1998 Kjetil Wiekhorst Jrgensen <jorgens+rpm@pvv.org>
- Initial release.
